Index: /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDataCU.cpp	(revision 292)
+++ /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDataCU.cpp	(revision 293)
@@ -4094,5 +4094,5 @@
     }    
   }
-#endif // HHI_INTER_VIEW_MOTION_PRED
+#endif //  H3D_IVMP 
 
 #if MERL_VSP_COMPENSATION_C0152
@@ -4167,5 +4167,5 @@
         bLeftAvai = true;
         iPosLeftAbove[0] = iCount;
-#endif  //HHI_INTER_VIEW_MOTION_PRED
+#endif  // H3D_IVMP 
 #if H3D_NBDV
         pcMvFieldNeighbours[iCount<<1    ].getMv().m_bDvMcp = false;
@@ -4221,5 +4221,5 @@
     iCount ++;
   }
-#endif // HHI_INTER_VIEW_MOTION_PRED
+#endif //  H3D_IVMP 
 
 #if MERL_VSP_COMPENSATION_C0152
@@ -4299,5 +4299,5 @@
     {
       iPosLeftAbove[1] = iCount;
-#endif // HHI_INTER_VIEW_MOTION_PRED
+#endif //  H3D_IVMP 
 #if H3D_NBDV
     pcMvFieldNeighbours[iCount<<1    ].getMv().m_bDvMcp = false;
@@ -4355,5 +4355,5 @@
     iCount ++;
   }
-#endif // HHI_INTER_VIEW_MOTION_PRED
+#endif //  H3D_IVMP 
 
 #if MERL_VSP_COMPENSATION_C0152
@@ -4503,5 +4503,5 @@
     }    
   }
-#endif //HHI_INTER_VIEW_MOTION_PRED
+#endif // H3D_IVMP 
 
 #if MERL_VSP_COMPENSATION_C0152
@@ -4619,5 +4619,5 @@
     iCount ++;
   }
-#endif // HHI_INTER_VIEW_MOTION_PRED
+#endif //  H3D_IVMP 
 
 #if MERL_VSP_COMPENSATION_C0152
@@ -6716,7 +6716,7 @@
 
 Void TComDataCU::fillMvpCandBase( UInt uiPartIdx, UInt uiPartAddr, RefPicList eRefPicList, Int iRefIdx, AMVPInfo* pInfo )
-#else // HHI_INTER_VIEW_MOTION_PRED 
+#else //  H3D_IVMP  
 Void TComDataCU::fillMvpCand ( UInt uiPartIdx, UInt uiPartAddr, RefPicList eRefPicList, Int iRefIdx, AMVPInfo* pInfo )
-#endif // HHI_INTER_VIEW_MOTION_PRED
+#endif //  H3D_IVMP 
 {
   PartSize eCUMode = getPartitionSize( 0 );
Index: /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 292)
+++ /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 293)
@@ -594,5 +594,5 @@
 #endif
   Bool          getIViewOrgDepthMvPred( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv );
-#endif // HHI_INTER_VIEW_MOTION_PRED
+#endif //  H3D_IVMP 
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   Bool*         getResPredAvail         ()                        { return m_pbResPredAvailable;        }
Index: /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp
===================================================================
--- /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 292)
+++ /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 293)
@@ -1152,5 +1152,5 @@
   return        true;
 }
-#endif // HHI_INTER_VIEW_MOTION_PRED
+#endif //  H3D_IVMP 
 
 
Index: /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComPic.h	(revision 292)
+++ /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TComPic.h	(revision 293)
@@ -80,5 +80,5 @@
   TComPicYuv*           m_pcOrgDepthMap;          //  original depth map
 #if H3D_NBDV
-  Bool          m_checked;
+  Bool        m_checked;
   UInt        m_uiRapRefIdx;
   RefPicList  m_eRapRefList;
Index: /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 292)
+++ /branches/HTM-5.1-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 293)
@@ -64,5 +64,5 @@
 #define LGE_DMM3_SIMP_C0044               1
 #endif
-#define FIX_DMM_CTX_INIT_C0034            1    // JCT3V-C0034 fix for wrong init type of DMM contexts (UChar instead of Short)
+#define FIX_DMM_CTX_INIT_C0034            1   // JCT3V-C0034 fix for wrong init type of DMM contexts (UChar instead of Short)
 
 ///// ***** SDC *********
@@ -71,15 +71,15 @@
 #define SAIT_SDC_C0096                    1   // JCT3V-C0096: Improved Simple Depth Coding(removal of DMM2 among four SDC modes(DC, Planar, DMM1 and DMM2))
 #endif
-#define FIX_SDC_ENC_C0143                 1    // JCT3V-C0143 fix for unnecessary encoder checks in case of SDC
+#define FIX_SDC_ENC_C0143                 1   // JCT3V-C0143 fix for unnecessary encoder checks in case of SDC
 
 ///// ***** TMVP/AMVP *********
-#define TMVP_DEPTH_SWITCH                 1 // JCT3V-B0092 additional encoder option only 
-#define QC_TMVP_MRG_REFIDX_C0047          1 // only enabled when QC_TMVP_IDX_MOD_B0046 is enabled.
-#define INTER_VIEW_VECTOR_SCALING_C0115   1 // JCT3V-C0115 Inter-view vector scaling for TMVP & flag
-#define INTER_VIEW_VECTOR_SCALING_C0116   1 // JCT3V-C0116 Inter-view vector scaling for AMVP
+#define TMVP_DEPTH_SWITCH                 1   // JCT3V-B0092 additional encoder option only 
+#define QC_TMVP_MRG_REFIDX_C0047          1   // only enabled when QC_TMVP_IDX_MOD_B0046 is enabled.
+#define INTER_VIEW_VECTOR_SCALING_C0115   1   // JCT3V-C0115 Inter-view vector scaling for TMVP & flag
+#define INTER_VIEW_VECTOR_SCALING_C0116   1   // JCT3V-C0116 Inter-view vector scaling for AMVP
 
 ///// ***** INTERVIEW MOTION PARAMETER PREDICTION *********
-#define H3D_IVMP                          1   // inter-view motion parameter prediction
-                                              // HHI_INTER_VIEW_MOTION_PRED
+#define H3D_IVMP                          1   // Inter-view motion parameter prediction
+                                              // HHI_INTER_VIEW_MOTION_PRED 
                                               // SAIT_IMPROV_MOTION_PRED_M24829, improved inter-view motion vector prediction
                                               // SHARP_INTERVIEW_DECOUPLE_B0111, decoupling inter-view candidate
@@ -256,7 +256,69 @@
 
 ///// ***** HM 6.1 *********
+
+// REMOVED HM 6.1 Macros 
 #define SKIPFRAME_BUGFIX                  1 ///< bug fix to enable skipFrame at decoder
 #define START_DECODING_AT_CRA             1 ///< H0496, start decoding at clear random access point
 #define NO_COMBINED_PARALLEL              1 ///< Disallow any combined usage of parallel tools among Tile, EntropySlice and Wavefont
+#define PARALLEL_MERGE                    1 ///< H0082 parallel merge/skip
+#define MVP_AT_ENTROPYSLICE_BOUNDARY      1  //< H0362 enable motion prediction accross entropy slice boundary
+#define FAST_DECISION_FOR_MRG_RD_COST     1  ////< H0178: Fast Decision for Merge 2Nx2N RDCost
+#define PIC_CROPPING                      1  ///< Picture cropping and size constraints
+#define NAL_REF_FLAG                      1  ///< Change nal_ref_idc to nal_ref_flag (JCTVC-F463)
+#define REMOVE_DIV_OPERATION      1  ///< H0238: Simplified intra horizontal and vertical filtering
+#define LOGI_INTRA_NAME_3MPM      1  ///< H0407: logical Intra mode naming (sequential angular mode numbering) and 3 MPM mode coding
+#define LEVEL_CTX_LUMA_RED        1  ///<H0130: Luma level context reduction
+#define REMOVE_INFER_SIGGRP       1  ///<H0131: Remove inferred significant_coeff_group_flag
+#define SET_MERGE_TMVP_REFIDX     1  ///< H0278/H0199: Setting the merge TMVP refidx to 0 for the non-first partition
+#define MULTILEVEL_SIGMAP_EXT     1  ///< H0526: multi-level significance map extended to smaller TUs
+#define MULTIBITS_DATA_HIDING     1  ///< H0481: multiple sign bit hiding
+#define DEQUANT_CLIPPING          1  ///< H0312/H0541: transformed coefficients clipping before de-quantization
+#define REMOVE_NON_SCALED         1 ///< H0164/H0250: Removal of non-scaled merge candidate
+#define MRG_IDX_CTX_RED           1 ///< H0251: Merge index context reduction
+#define SIMP_MRG_PRUN             1 ///< H0252: simplification of merge pruning process
+#define AMVP_PRUNING_SIMPLIFICATION         1     ///H0316: simplify the pruning process of AMVP by exempting the temporal candidate
+#define AMVP_ZERO_CHECKING_REMOVAL          1     ///H0239/H0316: remove zero motion vector checking of AMVP
+#define H0111_MVD_L1_ZERO         1  ///< H0111: modification of bi-prediction
+#define CLIPSCALEDMVP               1  ///< H0216: Clipping scaled MV to 16 bit
+#define UNIFIED_TRANSFORM_TREE      1   ///< H0123: unified tree structure for TU
+#define SIGMAP_CTX_SUBBLOCK       1 ///< H0290: 4x4 sub-block based region for significant_flag context selection
+#define LAST_CTX_REDUCTION        1  ///< H0537/H514: contexts reduction for last position coding
+#define AMP_CTX                   1 ///<H0545: context reduction for asymmetric partition
+#define RESTRICT_GR1GR2FLAG_NUMBER    1 ///< H0554: Throughput improvement of CABAC coefficients level coding
+#define EIGHT_BITS_RICE_CODE        1 ///< H0498 : 8 bits rice codes
+#define SAO_UNIT_INTERLEAVING      1   ///< H0273
+#define ALF_SINGLE_FILTER_SHAPE    1     //< !!! H0068: Single filter type : 9x7 cross + 3x3 square
+#define ALF_16_BA_GROUPS        1     ///< H0409 16 BA groups
+#define LCU_SYNTAX_ALF          1     ///< H0274 LCU-syntax ALF
+#define ALF_CHROMA_COEF_PRED_HARMONIZATION 1 ///< H0483: ALF chroma coeff pred harmonization
+#define CABAC_LINEAR_INIT       1     ///< H0535 : linear CABAC initialization
+#define UNIFIED_TRANSFORM       1     ///< H0492: unify square and non-square transform
+#define G519_TU_AMP_NSQT_HARMONIZATION  1   ///< G519: Harmonization of implicit TU, AMP and NSQT
+#define CHROMA_MODE_CODING                   1     //H0326/H0475 : 2-length fixed, bypass coding for chroma intra prediction mode
+#define NSQT_LFFIX                           1     ///< Bug fix related to NSQT and deblocking filter
+#define H0736_AVC_STYLE_QP_RANGE             1    ///< H0736: AVC style qp range and wrapping.
+#define H0204_QP_PREDICTION                  1    ///< H0204: improved QP prediction
+#define BURST_IPCM                        1           ///< H0051: Burst IPCM
+#define H0137_0138_LIST_MODIFICATION      1           // Enabled reference picture lists combination (H0137) and reference picture list modification (H0138) updates
+#define LTRP_MULT                       1           ///< enable/disable multiple long term reference pictures with same POC LSB
+#define OL_FLUSH 1          // Set to 1 to enable Wavefront Flush.
+#define FIXED_NUMBER_OF_TILES_SLICE_MODE                1
+#define SCALING_LIST                  1 //JCTVC-H0230/H0461/H0237
+#define DEFAULT_DC                    1 // JCTVC-H0242
+#define RPS_IN_SPS                    1 // Adopted during discussion of JCTVC-H0423
+#define H0412_REF_PIC_LIST_RESTRICTION 1
+#define H0566_TLA                     1
+#define H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER 1
+#define DBL_H0473_PART_1          1   //Deblocking filtering simplification
+#define DBL_CONTROL               1   //PPS deblocking_filter_control_present_flag (JCTVC-H0398); condition for inherit params flag in SH (JCTVC-H0424)
+#define DBL_STRONG_FILTER_CLIP    1   //Introduction of strong filter clipping in deblocking filter (JCTVC-H0275)
+#define H0388                       1 // JCTVC-H0388
+#define TILES_WPP_ENTRY_POINT_SIGNALLING        1 // JCTVC-H0556. Assumes either Tiles is ON or WPP is ON (not both simultaneously).
+#define REMOVE_TILE_DEPENDENCE                  1 // remove tile_boundary_independence_flag and dependent tiles
+#define TILES_OR_ENTROPY_SYNC_IDC               1 // tiles_or_entropy_coding_sync_idc flag
+#define COMPLETE_SLICES_IN_TILE     1 // Among the constraints between slices and tiles, all slices within a tile shall be complete (JCTVC-H0348/JCTVC-H0463) for SliceMode 1&2
+#define WPP_SIMPLIFICATION          1 // JCTVC-H0349/JCTVC-0517
+
+
 
 #define LOSSLESS_CODING                   1 ///< H0530: lossless and lossy (mixed) coding
@@ -265,5 +327,4 @@
 #endif
 
-#define PARALLEL_MERGE  1                   //< H0082 parallel merge/skip
 #define LOG2_PARALLEL_MERGE_LEVEL_MINUS2  0 //< H0082 parallel merge level 0-> 4x4, 1-> 8x8, 2->16x16, 3->32x32, 4->64x64
 
@@ -273,46 +334,7 @@
 #endif
 
-#define MVP_AT_ENTROPYSLICE_BOUNDARY      1  //< H0362 enable motion prediction accross entropy slice boundary
-
-#define FAST_DECISION_FOR_MRG_RD_COST     1  ////< H0178: Fast Decision for Merge 2Nx2N RDCost
-
-#define PIC_CROPPING              1  ///< Picture cropping and size constraints
-#define NAL_REF_FLAG              1  ///< Change nal_ref_idc to nal_ref_flag (JCTVC-F463)
-#define REMOVE_DIV_OPERATION      1  ///< H0238: Simplified intra horizontal and vertical filtering
-#define LOGI_INTRA_NAME_3MPM      1  ///< H0407: logical Intra mode naming (sequential angular mode numbering) and 3 MPM mode coding
-
-#define LEVEL_CTX_LUMA_RED        1  ///<H0130: Luma level context reduction
-#define REMOVE_INFER_SIGGRP       1  ///<H0131: Remove inferred significant_coeff_group_flag
-
-#define SET_MERGE_TMVP_REFIDX     1  ///< H0278/H0199: Setting the merge TMVP refidx to 0 for the non-first partition
-
-#define MULTILEVEL_SIGMAP_EXT     1  ///< H0526: multi-level significance map extended to smaller TUs
-#define MULTIBITS_DATA_HIDING     1  ///< H0481: multiple sign bit hiding
-
-#define DEQUANT_CLIPPING          1  ///< H0312/H0541: transformed coefficients clipping before de-quantization
-
-#define REMOVE_NON_SCALED         1 ///< H0164/H0250: Removal of non-scaled merge candidate
-#define MRG_IDX_CTX_RED           1 ///< H0251: Merge index context reduction
-#define SIMP_MRG_PRUN             1 ///< H0252: simplification of merge pruning process
-
-#define AMVP_PRUNING_SIMPLIFICATION         1     ///H0316: simplify the pruning process of AMVP by exempting the temporal candidate
-#define AMVP_ZERO_CHECKING_REMOVAL          1     ///H0239/H0316: remove zero motion vector checking of AMVP
-
-#define H0111_MVD_L1_ZERO         1  ///< H0111: modification of bi-prediction
 #define DISABLING_CLIP_FOR_BIPREDME         1  ///< Ticket #175
-
-#define CLIPSCALEDMVP               1  ///< H0216: Clipping scaled MV to 16 bit
-
-#define UNIFIED_TRANSFORM_TREE      1   ///< H0123: unified tree structure for TU
-
-#define SIGMAP_CTX_SUBBLOCK       1 ///< H0290: 4x4 sub-block based region for significant_flag context selection
-
 #define SIGMAP_CONST_AT_HIGH_FREQUENCY      1      ///< H0095 method2.1: const significance map at high freaquency
 
-#define LAST_CTX_REDUCTION        1  ///< H0537/H514: contexts reduction for last position coding
-
-#define AMP_CTX                   1 ///<H0545: context reduction for asymmetric partition
-
-#define RESTRICT_GR1GR2FLAG_NUMBER    1 ///< H0554: Throughput improvement of CABAC coefficients level coding
 #if RESTRICT_GR1GR2FLAG_NUMBER    //
 #define C1FLAG_NUMBER               8 // maximum number of largerThan1 flag coded in one chunk :  16 in HM5
@@ -320,22 +342,9 @@
 #endif
 
-#define EIGHT_BITS_RICE_CODE        1 ///< H0498 : 8 bits rice codes
-
-#define SAO_UNIT_INTERLEAVING      1   ///< H0273
 #define REMOVE_SAO_LCU_ENC_CONSTRAINTS_1 0  ///< disable the encoder constraint that does not test SAO/BO mode for chroma in interleaved mode
 #define REMOVE_SAO_LCU_ENC_CONSTRAINTS_2 0  ///< disable the encoder constraint that reduce the range of SAO/EO for chroma in interleaved mode
 #define REMOVE_SAO_LCU_ENC_CONSTRAINTS_3 0  ///< disable the encoder constraint that conditionally disable SAO for chroma for entire slice in interleaved mode
-
-#define ALF_SINGLE_FILTER_SHAPE    1     //< !!! H0068: Single filter type : 9x7 cross + 3x3 square
-
-#define ALF_16_BA_GROUPS        1     ///< H0409 16 BA groups
-#define LCU_SYNTAX_ALF          1     ///< H0274 LCU-syntax ALF
-#define ALF_CHROMA_COEF_PRED_HARMONIZATION 1 ///< H0483: ALF chroma coeff pred harmonization
-
-#define CABAC_LINEAR_INIT       1     ///< H0535 : linear CABAC initialization
-
-#define COLLOCATED_REF_IDX      1     ///< H0442: signal collocated reference index
-
-#define UNIFIED_TRANSFORM       1     ///< H0492: unify square and non-square transform
+#define COLLOCATED_REF_IDX      1           ///< H0442: signal collocated reference index
+
 
 #define MAX_NUM_SPS                32
@@ -354,5 +363,4 @@
 #define FAST_BIT_EST                1   ///< G763: Table-based bit estimation for CABAC
 
-#define G519_TU_AMP_NSQT_HARMONIZATION  1   ///< G519: Harmonization of implicit TU, AMP and NSQT
 
 #define MLS_GRP_NUM                         64     ///< G644 : Max number of coefficient groups, max(16, 64)
@@ -366,7 +374,4 @@
 
 
-#define CHROMA_MODE_CODING                   1     //H0326/H0475 : 2-length fixed, bypass coding for chroma intra prediction mode
-
-#define NSQT_LFFIX                           1     ///< Bug fix related to NSQT and deblocking filter
 #define NS_HAD                               1
 
@@ -374,11 +379,10 @@
 #define APS_BITS_FOR_ALF_BYTE_LENGTH 8
 
-#define H0736_AVC_STYLE_QP_RANGE             1    ///< H0736: AVC style qp range and wrapping.
-#define H0204_QP_PREDICTION                  1    ///< H0204: improved QP prediction
+
 
 #define HHI_RQT_INTRA_SPEEDUP             1           ///< tests one best mode with full rqt
 #define HHI_RQT_INTRA_SPEEDUP_MOD         0           ///< tests two best modes with full rqt
 
-#define BURST_IPCM                        1           ///< H0051: Burst IPCM
+
 
 #if HHI_RQT_INTRA_SPEEDUP_MOD && !HHI_RQT_INTRA_SPEEDUP
@@ -386,5 +390,5 @@
 #endif
 
-#define H0137_0138_LIST_MODIFICATION      1           // Enabled reference picture lists combination (H0137) and reference picture list modification (H0138) updates
+
 #if !H0137_0138_LIST_MODIFICATION
 #error "H0137_0138_LIST_MODIFICATION must be enabled for multi-view coding."
@@ -463,7 +467,4 @@
                                                     // this should be done with encoder only decision
                                                     // but because of the absence of reference frame management, the related code was hard coded currently
-#define LTRP_MULT                       1           ///< enable/disable multiple long term reference pictures with same POC LSB
-
-#define OL_FLUSH 1          // Set to 1 to enable Wavefront Flush.
 #define OL_FLUSH_ALIGN 0    // Align flush to byte boundary.  This preserves byte operations in CABAC (faster) but at the expense of an average
                             // of 4 bits per flush.
@@ -491,5 +492,5 @@
 #define FULL_NBIT 0 ///< When enabled, does not use g_uiBitIncrement anymore to support > 8 bit data
 
-#define FIXED_NUMBER_OF_TILES_SLICE_MODE                1
+
 #define AD_HOC_SLICES_FIXED_NUMBER_OF_LCU_IN_SLICE      1          ///< OPTION IDENTIFIER. mode==1 -> Limit maximum number of largest coding tree blocks in a slice
 #define AD_HOC_SLICES_FIXED_NUMBER_OF_BYTES_IN_SLICE    2          ///< OPTION IDENTIFIER. mode==2 -> Limit maximum number of bins/bits in a slice
@@ -520,33 +521,12 @@
 
 #define SCALING_LIST_OUTPUT_RESULT    0 //JCTVC-G880/JCTVC-G1016 quantization matrices
-#define SCALING_LIST                  1 //JCTVC-H0230/H0461/H0237
-
-#define DEFAULT_DC                    1 // JCTVC-H0242
-
-#define RPS_IN_SPS                    1 // Adopted during discussion of JCTVC-H0423
-
-#define H0412_REF_PIC_LIST_RESTRICTION 1
-
-#define H0566_TLA                     1
 #if H0566_TLA
 #define H0566_TLA_SET_FOR_SWITCHING_POINTS 1
 #endif
 
-#define H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER 1
-
-#define DBL_H0473_PART_1          1   //Deblocking filtering simplification
-#define DBL_CONTROL               1   //PPS deblocking_filter_control_present_flag (JCTVC-H0398); condition for inherit params flag in SH (JCTVC-H0424)
-#define DBL_STRONG_FILTER_CLIP    1   //Introduction of strong filter clipping in deblocking filter (JCTVC-H0275)
 
 #define CABAC_INIT_FLAG             1 // JCTVC-H0540
 #define CABAC_INIT_PRESENT_FLAG     1
 
-#define H0388                       1 // JCTVC-H0388
-
-#define TILES_WPP_ENTRY_POINT_SIGNALLING        1 // JCTVC-H0556. Assumes either Tiles is ON or WPP is ON (not both simultaneously).
-#define REMOVE_TILE_DEPENDENCE                  1 // remove tile_boundary_independence_flag and dependent tiles
-#define TILES_OR_ENTROPY_SYNC_IDC               1 // tiles_or_entropy_coding_sync_idc flag
-#define COMPLETE_SLICES_IN_TILE     1 // Among the constraints between slices and tiles, all slices within a tile shall be complete (JCTVC-H0348/JCTVC-H0463) for SliceMode 1&2
-#define WPP_SIMPLIFICATION          1 // JCTVC-H0349/JCTVC-0517
 
 // ====================================================================================================================