Index: branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1			      # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc/Cactus-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc/Kimono-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20
Index: branches/SHM-2.1-dev/cfg/per-sequence-svc/ParkScene-2x.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 304)
+++ branches/SHM-2.1-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 305)
@@ -18,5 +18,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
-NumScaledRefLayerOffsets1     : 1			# Number of scaled entry offsets for this layer
+NumScaledRefLayerOffsets1     : 1           # Number of scaled entry offsets for this layer
 ScaledRefLayerBottomOffset1   : -4          # offset for spatial alignment of the base and enhancement layers
 QP1                           : 20